diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py ns-3.32/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py
--- ns-3.31/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
@@ -6305,47 +6403,47 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::NotifyAddAddress(uint32_t interface, ns3::Ipv4InterfaceAddress address) [member function]
     cls.add_method('NotifyAddAddress', 
                    'void', 
                    [param('uint32_t', 'interface'), param('ns3::Ipv4InterfaceAddress', 'address')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::NotifyInterfaceDown(uint32_t interface) [member function]
     cls.add_method('NotifyInterfaceDown', 
                    'void', 
                    [param('uint32_t', 'interface')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::NotifyInterfaceUp(uint32_t interface) [member function]
     cls.add_method('NotifyInterfaceUp', 
                    'void', 
                    [param('uint32_t', 'interface')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::NotifyRemoveAddress(uint32_t interface, ns3::Ipv4InterfaceAddress address) [member function]
     cls.add_method('NotifyRemoveAddress', 
                    'void', 
                    [param('uint32_t', 'interface'), param('ns3::Ipv4InterfaceAddress', 'address')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::PrintRoutingTable(ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) const [member function]
     cls.add_method('PrintRoutingTable', 
                    'void', 
                    [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')], 
-                   is_const=True, visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private', is_const=True)
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): bool ns3::Ipv4NixVectorRouting::RouteInput(ns3::Ptr<const ns3::Packet> p, ns3::Ipv4Header const & header, ns3::Ptr<const ns3::NetDevice> idev, ns3::Ipv4RoutingProtocol::UnicastForwardCallback ucb, ns3::Ipv4RoutingProtocol::MulticastForwardCallback mcb, ns3::Ipv4RoutingProtocol::LocalDeliverCallback lcb, ns3::Ipv4RoutingProtocol::ErrorCallback ecb) [member function]
     cls.add_method('RouteInput', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet const >', 'p'), param('ns3::Ipv4Header const &', 'header'), param('ns3::Ptr< ns3::NetDevice const >', 'idev'), param('ns3::Callback< void, ns3::Ptr< ns3::Ipv4Route >, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'ucb'), param('ns3::Callback< void, ns3::Ptr< ns3::Ipv4MulticastRoute >, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'mcb'), param('ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'lcb'), param('ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, ns3::Socket::SocketErrno, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'ecb')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): ns3::Ptr<ns3::Ipv4Route> ns3::Ipv4NixVectorRouting::RouteOutput(ns3::Ptr<ns3::Packet> p, ns3::Ipv4Header const & header, ns3::Ptr<ns3::NetDevice> oif, ns3::Socket::SocketErrno & sockerr) [member function]
     cls.add_method('RouteOutput', 
                    'ns3::Ptr< ns3::Ipv4Route >', 
                    [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Ipv4Header const &', 'header'), param('ns3::Ptr< ns3::NetDevice >', 'oif'), param('ns3::Socket::SocketErrno &', 'sockerr')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## ipv4-nix-vector-routing.h (module 'nix-vector-routing'): void ns3::Ipv4NixVectorRouting::SetIpv4(ns3::Ptr<ns3::Ipv4> ipv4) [member function]
     cls.add_method('SetIpv4', 
                    'void', 
                    [param('ns3::Ptr< ns3::Ipv4 >', 'ipv4')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc ns-3.32/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc
--- ns-3.31/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc	2020-10-06 15:35:43.000000000 -0700
@@ -25,6 +25,7 @@
 #include "ns3/abort.h"
 #include "ns3/names.h"
 #include "ns3/ipv4-list-routing.h"
+#include "ns3/loopback-net-device.h"
 
 #include "ipv4-nix-vector-routing.h"
 
@@ -35,6 +36,7 @@
 NS_OBJECT_ENSURE_REGISTERED (Ipv4NixVectorRouting);
 
 bool Ipv4NixVectorRouting::g_isCacheDirty = false;
+Ipv4NixVectorRouting::Ipv4AddressToNodeMap Ipv4NixVectorRouting::g_ipv4AddressToNodeMap;
 
 TypeId 
 Ipv4NixVectorRouting::GetTypeId (void)
@@ -105,6 +107,10 @@
       rp->FlushNixCache ();
       rp->FlushIpv4RouteCache ();
     }
+
+  // IPv4 address to node mapping is potentially invalid so clear it.
+  // Will be repopulated in lazy evaluation when mapping is needed.
+  g_ipv4AddressToNodeMap.clear ();
 }
 
 void
@@ -342,29 +348,68 @@
     }
 }
 
-Ptr<Node>
-Ipv4NixVectorRouting::GetNodeByIp (Ipv4Address dest)
-{ 
+void
+Ipv4NixVectorRouting::BuildIpv4AddressToNodeMap (void)
+{
   NS_LOG_FUNCTION_NOARGS ();
 
-  NodeContainer allNodes = NodeContainer::GetGlobal ();
-  Ptr<Node> destNode;
-
-  for (NodeContainer::Iterator i = allNodes.Begin (); i != allNodes.End (); ++i)
+  for (NodeList::Iterator it = NodeList::Begin (); it != NodeList::End (); ++it)
     {
-      Ptr<Node> node = *i;
+      Ptr<Node> node = *it;
       Ptr<Ipv4> ipv4 = node->GetObject<Ipv4> ();
-      if (ipv4->GetInterfaceForAddress (dest) != -1)
+
+      if(ipv4)
         {
-          destNode = node;
-          break;
+          uint32_t numberOfDevices = node->GetNDevices ();
+
+          for (uint32_t deviceId = 0; deviceId < numberOfDevices; deviceId++)
+            {
+              Ptr<NetDevice> device = node->GetDevice (deviceId);
+
+              // If this is not a loopback device add the IPv4 address to the map
+              if ( !DynamicCast<LoopbackNetDevice>(device) )
+                {
+                  int32_t interfaceIndex = (ipv4)->GetInterfaceForDevice (node->GetDevice (deviceId));
+                  if (interfaceIndex != -1)
+                    {
+                      Ipv4InterfaceAddress ifAddr = ipv4->GetAddress (interfaceIndex, 0);
+                      Ipv4Address addr = ifAddr.GetLocal ();
+
+                      NS_ABORT_MSG_IF (g_ipv4AddressToNodeMap.count (addr),
+                                       "Duplicate IPv4 address (" << addr << ") found during NIX Vector map construction for node " << node->GetId ());
+
+                      NS_LOG_LOGIC ("Adding IPv4 address " << addr << " for node " << node->GetId () << " to NIX Vector IPv4 address to node map");
+                      g_ipv4AddressToNodeMap[addr] = node;
+                    }
+                }
+            }
         }
     }
+}
 
-  if (!destNode)
+Ptr<Node>
+Ipv4NixVectorRouting::GetNodeByIp (Ipv4Address dest)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+
+  // Populate lookup table if is empty.
+  if ( g_ipv4AddressToNodeMap.empty () )
+    {
+      BuildIpv4AddressToNodeMap ();
+    }
+
+  Ptr<Node> destNode;
+
+  Ipv4AddressToNodeMap::iterator iter = g_ipv4AddressToNodeMap.find(dest);
+
+  if(iter == g_ipv4AddressToNodeMap.end ())
     {
       NS_LOG_ERROR ("Couldn't find dest node given the IP" << dest);
-      return 0;
+      destNode = 0;
+    }
+  else
+    {
+      destNode = iter -> second;
     }
 
   return destNode;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/nix-vector-routing/model/ipv4-nix-vector-routing.h ns-3.32/src/nix-vector-routing/model/ipv4-nix-vector-routing.h
--- ns-3.31/src/nix-vector-routing/model/ipv4-nix-vector-routing.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/nix-vector-routing/model/ipv4-nix-vector-routing.h	2020-10-06 15:35:43.000000000 -0700
@@ -21,8 +21,6 @@
 #ifndef IPV4_NIX_VECTOR_ROUTING_H
 #define IPV4_NIX_VECTOR_ROUTING_H
 
-#include <map>
-
 #include "ns3/channel.h"
 #include "ns3/node-container.h"
 #include "ns3/node-list.h"
@@ -33,6 +31,9 @@
 #include "ns3/bridge-net-device.h"
 #include "ns3/nstime.h"
 
+#include <map>
+#include <unordered_map>
+
 namespace ns3 {
 
 /**
@@ -228,6 +229,11 @@
   void CheckCacheStateAndFlush (void) const;
 
   /**
+   * Build map from IPv4 Address to Node for faster lookup.
+   */
+  void BuildIpv4AddressToNodeMap (void);
+
+  /**
    * Flag to mark when caches are dirty and need to be flushed.  
    * Used for lazy cleanup of caches when there are many topology changes.
    */
@@ -244,6 +250,33 @@
 
   /** Total neighbors used for nix-vector to determine number of bits */
   uint32_t m_totalNeighbors;
+
+
+  /**
+   * \brief Hashing for the ipv4Address class
+   */
+  struct Ipv4AddressHash
+  {
+    /**
+     * \brief operator ()
+     * \param address the IPv4 address to hash
+     * \return the hash of the address
+     */
+    size_t operator() (const Ipv4Address &address) const
+    {
+      return std::hash<uint32_t>()(address.Get ());
+    }
+  };
+
+  /**
+   * Mapping of IPv4 address to ns-3 node.
+   *
+   * Used to avoid linear searching of nodes/devices to find a node in
+   * GetNodeByIp() method.  NIX vector routing assumes IP addresses
+   * are unique so mapping can be done without duplication.
+   **/
+  typedef std::unordered_map<Ipv4Address, ns3::Ptr<ns3::Node>, Ipv4AddressHash > Ipv4AddressToNodeMap;
+  static Ipv4AddressToNodeMap g_ipv4AddressToNodeMap;
 };
 } // namespace ns3
 
